class SyncQueue {

    private Object[] buffer;
    private int front, back, len;

    public SyncQueue(int size) {
        buffer = new Object[size];
        front = back = len = 0;
    }

    public synchronized void enqueue(Object value) {
        try {
            while (len == buffer.length) {
                wait();
            }
            buffer[back] = value;
            System.out.println("ENQUEUE: " + value.toString());
            back = (back+1) % buffer.length;
            len++;
            notifyAll();
        } catch (InterruptedException ex) { }
    }

    public synchronized Object dequeue() {
        Object value = null;
        try {
            while (len == 0) {
                wait();
            }
            value = buffer[front];
            System.out.println("DEQUEUE: " + value.toString());
            front = (front+1) % buffer.length;
            len--;
            notifyAll();
        } catch (InterruptedException ex) { }
        return value;
    }
}

